#ifndef MEMORY_H
#define MEMORY_H

#define X_FAST 0
typedef unsigned char byte;
typedef unsigned long ulong;
#ifdef DOS
typedef unsigned WORD;
#endif

#define Hi(x) (*((byte *) &x+1))
#define Lo(x) (*((byte *) &x))
#define ERR_NOERR          0x00                       /* Pas d'erreur */
#define ERR_NOTIMPLEMENTED 0x80          /* Fonction appel,e inconnue */
#define ERR_VDISKFOUND     0x81             /* Ram disk VDISK d,tect, */
#define ERR_A20            0x82    /* Erreur sur canal d'adresses A20 */
#define ERR_GENERAL        0x8E  /* Erreur pilote _ caractSre g,n,ral */
#define ERR_UNRECOVERABLE  0x8F                /* Erreur irratrapable */
#define ERR_HMANOTEXIST    0x90                    /* HMA introuvable */
#define ERR_HMAINUSE       0x91                   /* HMA d,j_ appel,e */
#define ERR_HMAMINSIZE     0x92            /* Taille HMA insuffisante */
#define ERR_HMANOTALLOCED  0x93                   /* HMA non affect,e */
#define ERR_A20STILLON     0x94  /* Canal d'adresses A20 encore actif */
#define ERR_OUTOMEMORY     0xA0 /* Plus de m,moire ,tendue disponible */
#define ERR_OUTOHANDLES    0xA1 /* Tous identificateurs XMS sont pris */
#define ERR_INVALIDHANDLE  0xA2            /* Identificateur invalide */
#define ERR_SHINVALID      0xA3     /* Identificateur source invalide */
#define ERR_SOINVALID      0xA4           /* D,calage source invalide */
#define ERR_DHINVALID      0xA5       /* Identif destination invalide */
#define ERR_DOINVALID      0xA6      /* D,calage destination invalide */
#define ERR_LENINVALID     0xA7 /* Longueur invalide pr fonction Move */
#define ERR_OVERLAP        0xA8              /* Recouvrement interdit */
#define ERR_PARITY         0xA9                   /* Erreur de parit, */
#define ERR_EMBUNLOCKED    0xAA               /* UMB n'est pas bloqu, */
#define ERR_EMBLOCKED      0xAB              /* UMB est encore bloqu, */
#define ERR_LOCKOVERFLOW   0xAC   /* D,bordement compteur blocage UMB */
#define ERR_LOCKFAIL       0xAD      /* L'UMB ne peut pas tre bloqu, */
#define ERR_UMBSIZETOOBIG  0xB0          /* Plus petit UMB disponible */
#define ERR_NOUMBS         0xB1              /* Plus d'UMB disponible */
#define ERR_INVALIDUMB     0xB2    /* adresse du segment UMB invalide */

struct memh
{
	unsigned linesize;
	unsigned nlines;
	byte *ptr;
	int XMShandle;
};

typedef struct memh *mem_hand;

#ifdef DOS
typedef struct tagXMSRegs
{
	WORD AX,
	     BX,
	     DX,
	     SI,
	     Segment;
} XMSRegs;
#endif

typedef struct tagEMMS
{
	long LenB;
	int  SHandle;
	long SOffset;
	int  DHandle;
	long DOffset;
} EMMS;

int xinit(void);
mem_hand xalloc (unsigned linesize, unsigned nlines);
void xfree (mem_hand h);
int xput (byte * src, unsigned line, mem_hand handle);
byte *xget (unsigned line, mem_hand handle);
int setXMstrat (char *strategy);
void SetReadMode (mem_hand handle, int read_mode);
char *mem_type (mem_hand handle);
void xmemuse(long* xms, long* conv);
int secure_atoi(char *);

#endif